-- -----------------------------------------------------------------------------

local ADDON_NAME, ns = ...
local WFEZ_D,WFEZ_O,WFEZ_F,L = ns.datas,ns.functions,ns.frames,ns.locales

-- -----------------------------------------------------------------------------
-- MAIN
-- -----------------------------------------------------------------------------

WFEZ_F.main       = WFEZ_O:FRAM("WFEZframe","Frame",UIParent,nil,
                                "TOP",0,-200,nil,nil, -- position
                                WFEZ_D.sizes.PANNEL,500) -- size
WFEZ_F.main:Hide()
WFEZ_F.main:SetHeight(GetScreenHeight()/1.8)
WFEZ_F.main_f     = WFEZ_O:FADE("WFEZframefade",WFEZ_F.main,true,.5)
WFEZ_F.main:SetResizable(true)
WFEZ_F.main:SetMinResize(300,GetScreenHeight()*.2)
WFEZ_F.main:SetMaxResize(GetScreenWidth()*5/8,GetScreenHeight()*18/20)

WFEZ_F.main:SetMovable(true)
WFEZ_F.main:SetScript("OnMouseDown", function() WFEZ_F.main:StartMoving() end)
WFEZ_F.main:SetScript("OnMouseUp"  , function() WFEZ_F.main:StopMovingOrSizing() end)

WFEZ_F.main_rb    = WFEZ_O:FRAM("WFEZframeRB","Button",WFEZ_F.main,nil,
                                "BOTTOMRIGHT", 0,0,nil,nil, -- position
                                WFEZ_D.fonts.TXT,WFEZ_D.fonts.TXT) -- size
WFEZ_F.main_rb:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Up")
WFEZ_F.main_rb:SetHighlightTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Highlight")
WFEZ_F.main_rb:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIM-SizeGrabber-Down")
WFEZ_F.main_rb:SetScript("OnMouseDown", function() WFEZ_F.main:StartSizing("BOTTOMRIGHT")  end)
WFEZ_F.main_rb:SetScript("OnMouseUp"  , function()
    WFEZ_F.main:StopMovingOrSizing()
    WF_ez_DBC.width = WFEZ_F.main:GetWidth()
    WFEZ_D.sizes.PANNEL = WFEZ_F.main:GetWidth()
end)
WFEZ_F.main:SetFrameStrata("HIGH")

tinsert(UISpecialFrames,"WFEZframe")
WFEZ_F.main:SetScript("OnShow", function() WFEZ_D.isOpen = true   C_FriendList.ShowFriends() C_GuildInfo.GuildRoster() WFEZ_O:SET_FRIENDS() end)
WFEZ_F.main:SetScript("OnHide", function() WFEZ_D.isOpen = false  end)

-- -----------------------------------------------------------------------------
-- BOTTOM
-- -----------------------------------------------------------------------------

WFEZ_F.bottom      = WFEZ_O:FRAM("WFEZbottom","Frame",WFEZ_F.main,nil)
WFEZ_F.bottom:SetPoint("TOPLEFT"    ,WFEZ_F.main, "BOTTOMLEFT"  ,WFEZ_D.sizes.MARGES,WFEZ_D.sizes.PANNELINFOS_H+WFEZ_D.sizes.MARGES)
WFEZ_F.bottom:SetPoint("BOTTOMRIGHT",WFEZ_F.main, "BOTTOMRIGHT" ,-(WFEZ_D.sizes.MARGES),WFEZ_D.sizes.MARGES)
WFEZ_F.bottom_f    = WFEZ_O:FADE("WFEZbottomfade",WFEZ_F.bottom,true,.8)

WFEZ_F.bottnc = WFEZ_O:FRAM("WFEZbottom_c","Button",WFEZ_F.bottom,"UIPanelButtonTemplate","LEFT",WFEZ_F.bottom,"LEFT",WFEZ_D.sizes.MMARGS,0, WFEZ_D.fonts.TXT_12*2.3, WFEZ_D.fonts.TXT_12*2.3)
WFEZ_F.bottnc:DisableDrawLayer("BACKGROUND")
WFEZ_F.bottnc:SetHighlightTexture('')
WFEZ_F.bottnc:SetNormalTexture("Interface\\CHARACTERFRAME\\Disconnect-Icon")
WFEZ_F.bottnc:SetPushedTexture("Interface\\CHARACTERFRAME\\Disconnect-Icon")
WFEZ_F.bottnc:SetScript("OnClick", function()
    if WF_ez_DBC.enable_offs then WF_ez_DBC.enable_offs = nil  WFEZ_F.bottnc:SetAlpha(.4)
                             else WF_ez_DBC.enable_offs = true WFEZ_F.bottnc:SetAlpha( 1) end WFEZ_O:REFRESH_FRIENDS() end)
WFEZ_F.bottnc.tooltipText = "VIEW OFFLINE PLAYER";

WFEZ_F.bottnd = WFEZ_O:FRAM("WFEZbottom_d","Button",WFEZ_F.bottom,"UIPanelButtonTemplate","LEFT",WFEZ_F.bottnc,"RIGHT",0,0, WFEZ_D.fonts.TXT_14, WFEZ_D.fonts.TXT_14)
WFEZ_F.bottnd:DisableDrawLayer("BACKGROUND")
WFEZ_F.bottnd:SetHighlightTexture('')
WFEZ_F.bottnd:SetNormalTexture("Interface\\CHATFRAME\\UI-ChatIcon-WoW")
WFEZ_F.bottnd:SetPushedTexture("Interface\\CHATFRAME\\UI-ChatIcon-WoW")
WFEZ_F.bottnd:SetScript("OnClick", function()
    if WF_ez_DBC.onlyig_offs then WF_ez_DBC.onlyig_offs = nil  WFEZ_F.bottnd:SetAlpha(.4)
                             else WF_ez_DBC.onlyig_offs = true WFEZ_F.bottnd:SetAlpha( 1) end WFEZ_O:REFRESH_FRIENDS() end)
WFEZ_F.bottnd.tooltipText = "VIEW ONLY IN GAME PLAYER";

WFEZ_F.bottne = WFEZ_O:FRAM("WFEZbottom_e","Button",WFEZ_F.bottom,"UIPanelButtonTemplate","LEFT",WFEZ_F.bottnd,"RIGHT",WFEZ_D.sizes.MARGES,0, WFEZ_D.fonts.TXT_14, WFEZ_D.fonts.TXT_14)
WFEZ_F.bottne:DisableDrawLayer("BACKGROUND")
WFEZ_F.bottne:SetHighlightTexture('')
WFEZ_F.bottne:SetNormalTexture("Interface\\CHATFRAME\\UI-ChatConversationIcon")
WFEZ_F.bottne:SetPushedTexture("Interface\\CHATFRAME\\UI-ChatConversationIcon")
WFEZ_F.bottne:SetScript("OnClick", function()
    if WF_ez_DBC.showguildie then WF_ez_DBC.showguildie = nil  WFEZ_F.bottne:SetAlpha(.4)
                             else WF_ez_DBC.showguildie = true WFEZ_F.bottne:SetAlpha( 1) end WFEZ_O:SET_FRIENDS() WFEZ_O:UPDATE_LDB() end)
WFEZ_F.bottne.tooltipText = "VIEW GUILD";


WFEZ_F.clsbtn = WFEZ_O:FRAM("WFEZ_clsbtn","Button",WFEZ_F.main,"UIPanelButtonTemplate","TOPLEFT",WFEZ_F.main,"TOPRIGHT",WFEZ_D.sizes.MARGES*2.4,WFEZ_D.fonts.TXT_05+1,WFEZ_D.sizes.PANNELINFOS_H*1.14,WFEZ_D.sizes.PANNELINFOS_H*1.14)
WFEZ_F.clsbtn:DisableDrawLayer("BACKGROUND")
WFEZ_F.clsbtn:SetHighlightTexture('')
WFEZ_F.clsbtn:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
WFEZ_F.clsbtn:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up")
WFEZ_F.clsbtn:SetScript("OnClick", function() WFEZ_F.main:Hide() end)
WFEZ_F.clsbtn.tooltipText = "CLOSE";

WFEZ_F.bottom_TXT = WFEZ_O:FONT("WFEZ_TXT",WFEZ_F.bottom, "LEFT",WFEZ_F.bottne,"RIGHT",WFEZ_D.sizes.MARGES*2,0)
WFEZ_F.bottom_TXT:SetPoint("RIGHT",WFEZ_F.clsbtn,"RIGHT",0,0)
WFEZ_F.bottom_TXT:SetTextColor(.4,.4,.4,1)

-- -----------------------------------------------------------------------------
-- MARGES
-- -----------------------------------------------------------------------------

WFEZ_F.margb      = WFEZ_O:FRAM("WFEZmargb","Frame",WFEZ_F.main,nil)
WFEZ_F.margb:SetPoint("TOPLEFT"     ,WFEZ_F.main, "TOPLEFT" ,  WFEZ_D.sizes.MARGES ,-(WFEZ_D.sizes.MARGES))
WFEZ_F.margb:SetPoint("BOTTOMRIGHT" ,WFEZ_F.main, "TOPRIGHT",-(WFEZ_D.sizes.MARGES),-(WFEZ_D.sizes.MMARGS*1.5))
WFEZ_F.margb_f    = WFEZ_O:FADE("WFEZmargbfade",WFEZ_F.margb,true,.6)

WFEZ_F.margt      = WFEZ_O:FRAM("WFEZmargt","Frame",WFEZ_F.main,nil)
WFEZ_F.margt:SetPoint("TOPLEFT"    ,WFEZ_F.bottom, "TOPLEFT" ,0,WFEZ_D.sizes.MARGES)
WFEZ_F.margt:SetPoint("BOTTOMRIGHT",WFEZ_F.bottom, "TOPRIGHT",0,WFEZ_D.sizes.MMARGS)
WFEZ_F.margt_f    = WFEZ_O:FADE("WFEZmargtfade",WFEZ_F.margt,true,.6)

-- -----------------------------------------------------------------------------
-- SCROLL FRAME
-- -----------------------------------------------------------------------------

WFEZ_F.scrollf    = WFEZ_O:FRAM("WFEZscrollf","ScrollFrame",WFEZ_F.main,nil)
WFEZ_F.scrollf:SetPoint("TOPLEFT"    ,WFEZ_F.margb, "BOTTOMLEFT",0,0)
WFEZ_F.scrollf:SetPoint("BOTTOMRIGHT",WFEZ_F.margt, "TOPRIGHT"  ,0,0)
WFEZ_F.scrollf_f  = WFEZ_O:FADE("WFEZscrollffade",WFEZ_F.scrollf,true,.6)

WFEZ_F.scrollb    = WFEZ_O:FRAM("WFEZscrollb","Slider",WFEZ_F.scrollf,"UIPanelScrollBarTemplate",
                                "TOPLEFT", WFEZ_F.main,"TOPRIGHT", 4, -(WFEZ_D.fonts.TXT_14))
WFEZ_F.scrollb:SetPoint("BOTTOMLEFT", WFEZ_F.main, "BOTTOMRIGHT",0,WFEZ_D.fonts.TXT_14)
WFEZ_F.scrollb:SetMinMaxValues(1, 200)
WFEZ_F.scrollb:SetValueStep(10)
WFEZ_F.scrollb:SetValue(0)
WFEZ_F.scrollb.scrollStep = 10

WFEZ_F.scrollb:SetScript("OnValueChanged",function (self, value) self:GetParent():SetVerticalScroll(value) end)

WFEZ_F.scrollb                  :SetWidth( WFEZ_D.fonts.TXT_14)
WFEZ_F.scrollb.ThumbTexture     :SetWidth( WFEZ_D.fonts.TXT_14)
WFEZ_F.scrollb.ThumbTexture     :SetHeight(WFEZ_D.fonts.TXT_14)
WFEZ_F.scrollb.ScrollDownButton :SetWidth( WFEZ_D.fonts.TXT_14)
WFEZ_F.scrollb.ScrollDownButton :SetHeight(WFEZ_D.fonts.TXT_14)
WFEZ_F.scrollb.ScrollUpButton   :SetWidth( WFEZ_D.fonts.TXT_14)
WFEZ_F.scrollb.ScrollUpButton   :SetHeight(WFEZ_D.fonts.TXT_14)

-- -----------------------------------------------------------------------------
-- CHILD
-- -----------------------------------------------------------------------------

WFEZ_F.child      = WFEZ_O:FRAM("WFEZchild","Frame",WFEZ_F.scrollf)
WFEZ_F.child:SetSize(1,1)

WFEZ_F.play_name_maxwidth = WFEZ_O:FRAM("WFEZfr_play_name","Frame",WFEZ_F.main,nil,"TOPLEFT",WFEZ_F.scrollf,"TOPLEFT",nil,nil,80,1)

WFEZ_F.scrollf:SetScrollChild(WFEZ_F.child)
WFEZ_F.scrollf:SetScript("OnMouseWheel", function (self, value) value = value*-1 val = WFEZ_F.scrollb:GetValue()+value*10 WFEZ_F.scrollb:SetValue(val) end)
WFEZ_F.scrollb:SetScript("OnMouseWheel", function (self, value) value = value*-1 val = WFEZ_F.scrollb:GetValue()+value*10 WFEZ_F.scrollb:SetValue(val) end)

-- -----------------------------------------------------------------------------

SLASH_WFEZ1 = "/woezfriends"
SLASH_WFEZ2 = "/friends"
SlashCmdList.WFEZ = function() WFEZ_O:CHECK_OPEN() end

-- -----------------------------------------------------------------------------
-- TOOLTIP
-- -----------------------------------------------------------------------------

local LibStub = _G.LibStub
if not LibStub then return end
WFEZ_F.ldb = LibStub:GetLibrary("LibDataBroker-1.1", true)

-- WFEZ_F.dataobj = WFEZ_F.ldb:NewDataObject("WOEZ FRIENDS",
-- 	{ icon = "Interface\\ChatFrame\\UI-ChatIcon-Battlenet", type = "data source"})
--

WFEZ_F.dataobj = WFEZ_F.ldb:NewDataObject("WOEZ FRIENDS",{
		type = "data source",
		icon = "Interface\\ChatFrame\\UI-ChatIcon-Battlenet",
		text = WFEZ_D.TXTUP ,
		OnClick = function() WFEZ_O:CHECK_OPEN() end,
	})

-- function WFEZ_F.dataobj:OnClick() WFEZ_O:CHECK_OPEN() end


--	local LDBIcon = LDB and LibStub("LibDBIcon-1.0", true)
--	if LDB then
--	    local OmenLauncher = LDB:NewDataObject("WFEZ_FRIENDS", {
--	        type = "launcher",
--	        icon = "Interface\\AddOns\\WO_ezfriendslist\\logo",
--	        OnClick = function(clickedframe, button)
--	            -- if button == "RightButton" then WFEZ_O:CHECK_OPEN() else Omen:Toggle() end
--				WFEZ_O:CHECK_OPEN()
--	        end,
--	        OnTooltipShow = function(tt)
--	            tt:AddLine(self.defaultTitle)
--	            tt:AddLine("|cffffff00" .. L["Click|r to toggle the Omen window"])
--	            tt:AddLine("|cffffff00" .. L["Right-click|r to open the options menu"])
--	        end,
--	    })
--	    if LDBIcon then
--	        LDBIcon:Register("WFEZ_FRIENDS", OmenLauncher, db.MinimapIcon)
--	    end
--	end

-- -----------------------------------------------------------------------------